      program collat
      integer infl, outfl, nmlen, hdlen, reclen, lnlen, ndiff
      parameter(infl = 2, outfl = 3, nmlen = 25,
     +          hdlen = 8, reclen = 10, lnlen = 132, ndiff = 2)
      character label, innm*(nmlen), outnm*(nmlen), line*(lnlen)
      integer upto, n, newn, i, j, eof, temp
      real zeta, newz,
     +     val(reclen), newval(reclen),
     +     diff(reclen, ndiff), newdff(reclen, ndiff)

      label = 'A'
      innm  = 'K10000A.OUT'
      outnm = 'SYS$SCRATCH:K10000.OUT'

      open(unit = outfl, file = outnm,
     +  carriagecontrol = 'list', status = 'new')
      open(unit = infl, file = innm, status = 'old')
      do 10 i = 1, hdlen
        read(infl, '(a)') line
        write(outfl, '(a)') line
10    continue
      upto = 10000

c---------------process--------
12345 continue
      call getrec(infl, n, zeta, val, diff)
      read(infl, *, iostat = eof) newn
      if (eof .lt. 0) newn = upto
      upto = upto - reclen
      print * ,'new n is ',newn,'  upto is ',upto
      if (upto .eq. newn) then
           backspace(infl)
           call putrec(outfl, n, zeta, val, diff)
      else
           close(infl)
           label = char(ichar(label) + 1)
           innm(7:7) = label
             open(unit = infl, file = innm, status = 'old')
           do 20 i = 1, hdlen
                read(infl, *) 
20         continue
           write( 6, '(a)') innm
           call getrec(infl, temp, newz, newval, newdff)
           call putrec(   6, temp, newz, newval, newdff)
           do 30 i = newn - upto, 1, -1
                val(i) = newval(i)
                do 25 j = 1, ndiff
                     diff(i, j) = newdff(i, j)
25              continue
30          continue
            call putrec(outfl, n, zeta, val, diff)
            read (infl, *) newn
            backspace(infl)
            call zero(val, diff)
1000        if (upto .eq. newn) then
            else
                call putrec(    6, upto, 0.0, val, diff)
                call putrec(outfl, upto, 0.0, val, diff)
                upto = upto - reclen
                goto 1000
            endif
      endif
      if (upto .gt. 10) goto 12345
      call getrec(infl,  n, zeta, val, diff)
      call putrec(outfl, n, zeta, val, diff)
      read (infl, *) n, zeta
      write (outfl, '(i8, f12.8)') n, zeta
      end
c--------------------------------------------------------------
      subroutine getrec(flnum, n, zeta, val, diff)
      integer flnum, reclen, ndiff, indiff
      parameter(reclen = 10, ndiff = 2, indiff = 0)
      integer n
      real zeta, val(reclen), diff(reclen, ndiff)
      read(flnum, *) n, zeta, (val(i), i = reclen, 1, -1)
      do 10 j = 1, indiff
        read(flnum, *) (diff(i, j), i = reclen, 1, -1)
10    continue
      do 20 j = indiff + 1, 5
        read(flnum, *)
20    continue
      return
      end
c-------------------------------------------------------------
      subroutine putrec(flnum, n, zeta, val, diff)
      integer flnum, reclen, ndiff, outdf
      parameter(reclen = 10, ndiff = 2, outdf = 0)
      integer n
      real zeta, val(reclen), diff(reclen, ndiff)
      write(flnum, '(i8, f12.8, 10 f11.6)')
     +      n, zeta, (val(i), i = reclen, 1, -1)
      do 10 j = 1, outdf
        write(flnum, '(21x, 10 e11.3)')
     +       (diff(i, j), i = reclen, 1, -1)
10    continue
      return
      end
c-------------------------------------------------------------
      subroutine zero(val, diff)
      integer reclen, ndiff, i, j
      parameter(reclen = 10, ndiff = 2)
      real val(reclen), diff(reclen, ndiff)
      do 10 j = 1, reclen
            do 5 i = 1, ndiff
                    diff(j, i) = 0.0
5           continue
            val(j) = 0.0
10    continue
      return
      end
c--------------------------------------------------------------
