C--------------------------------------------------------------
C
C
C MGRID FORMS A COARSE GRID FOR LAMBDA, FOR N=M, THEN THE COARSE GRID OF
C (LAMBDA,Q)'S IS CALCULATED DIRECTLY. 
C 
C   FOR N=M, WE KNOW QMSTAR(Z)=-Z/(1.0-A)
C
C COARSE GRID-FORMING
C
C---------------------------------------------------------------------
      SUBROUTINE MGRID(FX,QNEW,LNVAL,LLIM,M,A,N,OLDL,ZETA,ZETPRV)
      INTEGER LNVAL(6),ZNVAL(6),N1,NCOUNT,NCNT,M,N,MESSAG,RTFLG
      REAL A,OLDL,ZETA,ZETPRV,FX,QINTGL,QNEW,PREC,LLIM(0:6),
     &     ZLIM(0:6),ALIM,BLIM,HINTVL,AI,AN,OLDLAM(200),OLDQ(200)
      COMMON /GRD/ OLDLAM,OLDQ,NCNT
C      WRITE(6,*)'  IN MGRID--------'
      RTFLG=1
      NCOUNT=0
      PREC=0.00000001
14000 DO 3 J=1,6
C !!! CHECK LINE 998, IS IT THE CORRECT PLACE TO JUMP TO?
        IF (LNVAL(J) .EQ. 0) GOTO 998
        ALIM=LLIM(J-1)
        BLIM=LLIM(J)
        AN=LNVAL(J)
        HINTVL=(ALIM-BLIM)/AN
        N1=LNVAL(J)
        DO   1   I=1,N1
          NCOUNT=NCOUNT+1
          AI=I-1
C  SHOULD THIS BE BLIM +, OR ALIM -  ??
            OLDLAM(NCOUNT)=ALIM-HINTVL*AI
            OLDL=OLDLAM(NCOUNT)
C N=M THEN NO INTEGRATION REQUIRED; CALCULATION IS DIRECT
            OLDQ(NCOUNT)=-OLDL/(1.0-A)
1       CONTINUE
3     CONTINUE
998   CONTINUE
C	 WRITE(6,1010)
1010    FORMAT(' ',11X,'OLDLAM',14X,'OLDQ(OLDLAM)')
C      WRITE(6,1000)((OLDLAM(I),OLDQ(I)),I=1,NCOUNT)
      CALL SORT(OLDLAM,OLDQ,NCOUNT)
      OLDLAM(NCNT)=OLDLAM(NCOUNT)
      OLDQ(NCNT)=OLDQ(NCOUNT)
C      WRITE(6,1000)((OLDLAM(I),OLDQ(I)),I=1,NCNT)
1000  FORMAT(' ',40(/2F16.6))
C        WRITE(6,1030)
1030    FORMAT('  ',50('-'))
C        WRITE(6,*)
C      WRITE(6,*)'--------END OF MGRID---------'
C      WRITE(6,*)'LNVAL'
C      WRITE(6,*)LNVAL
C      WRITE(6,*)'LLIM'
C      WRITE(6,*)LLIM
      RETURN
      END
C
C
C------------------------------------------------------------------------------
