C Called by SUBROUTINEs LGRID, LROOT, GEOM.
C CALLS SUBROUTINEs ZRANGE, TCASES, TROOT, DIVROM, and
C 	FUNCTION QNEW.
C
      SUBROUTINE SOLVE(FX,QNEW,LAMBDA,SOLUTN,UNKNW1,
     &                 M,A,N,OLDL,ZETA,RTFLG,INTPRV)
      INTEGER POSFLG,NVAL(6),MAX,NCOUNT,N,MESSAG,RTFLG,M,NOVAL,
     &        DIVFLG,NROOTS,NFRMLA
      REAL*4 A,LAMBDA,LOWLIM,UPLIM,FX,QNEW,LIM(0:6),SOLUTN,SOLN,
     &     UNKNW1,OLDL,ZETA,EPS(3),INTPRV,T1,T2,PREC
      REAL*8 DDELTA
C In COMMON with main PROGRAM QBANDIT. (?--INIT?)
      COMMON /PRECN/ EPS
C In COMMON with SUBROUTINE QSIGNS.
      COMMON /SLVQSN/ T1,T2,NROOTS
C In COMMON with FUNCTION FX
      COMMON /SLVFX/ ZETA2
      DATA POSFLG,NVAL,MAX,NCOUNT,DIVFLG /10*0/
C      PRINT *,'SOLVE: LAMBDA = ',LAMBDA,'  N = ',N,' RTFLG = ',RTFLG
      DATA LIM /7*0.0/
C      WRITE(6,*)'----------------SOLVE------------------------------'
      ZETA2=ZETA
      SOLUTN=0.0
      CALL ZRANGE(LAMBDA,MAX,LIM,NVAL,M,A,N,OLDL,ZETA,RTFLG)
      	CALL TCASES(N,LAMBDA,ZETA,DDELTA,NROOTS,NFRMLA)
      	CALL TROOT(N,ZETA,LAMBDA,DDELTA,NROOTS,NFRMLA,T1,T2)
C      IF (N .EQ. 98 .OR. N .EQ. 50 .OR. N .EQ. 18 .OR. N .EQ. 2)
C     &    PRINT *,'SOLVE: T1 = ',T1,'    T2 = ',T2,'   INTPRV = ',INTPRV
      DO 100 J=1,MAX
      	SOLN=0.0
      	DIVFLG=0
      	NOVAL=NVAL(J)
      	IF (NOVAL .EQ. 0) GOTO 100
      	IF (N .LT. 21) NOVAL=3		      ! Hi precision for N <= 20
      	IF (RTFLG .EQ. 0) THEN
C Root-finding
      	  PREC=EPS(NOVAL)*LAMBDA
      	ELSE IF (RTFLG .EQ. 1) THEN
C Coarse grid-forming
      	  PREC=EPS(NOVAL)*INTPRV
      	ELSE
C Root flag not equal to 0 or 1: impossible.
      	  PRINT *,'SOLVE: Root-flag (must = 0 or 1) = ',RTFLG
          STOP 'Error in SOLVE.'
      	END IF
C      PRINT *,'SOLVE: LAMBDA = ',LAMBDA,'  N = ',N
C      PRINT *,'SOLVE: PREC   = ',PREC,' INTPRV = ',INTPRV
C      WRITE(6,*)' SOLVE:  J = ',J,' DIVFLG = ',DIVFLG
C      WRITE(6,*)'         LIMITS = ',LIM(J-1),LIM(J)
        CALL DIVROM(FX,LIM(J-1),LIM(J),SOLN,PREC,A,N,LAMBDA,
     &              NROOTS,T1,T2,DIVFLG)
	SOLUTN=SOLUTN+SOLN
100   CONTINUE
999   UNKNW1=QNEW(LAMBDA,SOLUTN,A,N)
      RETURN
      END
C
C
C---------------------------------------------------------------------
