C FUNCTION FX defines the function to be
C integrated and is used in conjunction with SUBROUTINE SIMP
C and a main program.
C
C
      FUNCTION FX(Z,A,N,LAMBDA)
      INTEGER N,NZ,NCNT,FLAG
      REAL A,LAMBDA,EPS,EPSEXP,Z,PI,OLDL,OLDLAM(200),
     &     OLDQ(200),Z1,Z2,Z3
      DOUBLE PRECISION QZ,Q1,Q2,Q3,AN,DZ,DLAMBDA,EXPNT,EXPNT2
      COMMON /GRD/ OLDLAM,OLDQ,NCNT
      COMMON /FXFLAG/ FLAG
      DATA NZ,AN,EXPNT,OLDL,Q1,Q2,Q3,Z1,Z2,Z3,QZ /0,10*0.0/
C
C  Quadratic interpolation for Qnstar(Z), or QZ.
C
C  Find LAMBDA(N) in old grid such that two LAMBDA are
C  just less than, and one just more than, Z.
C
      FLAG=0
      DZ=Z
      DLAMBDA=LAMBDA
      AN=N
      EPSEXP=1.0E-30
      IF (Z .LT. OLDLAM(2)) THEN
        QZ=-Z/(1.0-A)
        GO TO 999
      END IF
      EPS=0.000000001
      DO 10 I=3,NCNT
C   28=10+8+6+4+0+0 IN LRANGE
C
      	OLDL=OLDLAM(I)
        IF (ABS(Z-OLDL) .LT. EPS) THEN
      	  QZ=OLDQ(I)
      	  GOTO 999
        ELSE IF (Z .LT. OLDL) THEN
          NZ=I
          GO TO 100
        END IF
10    CONTINUE
      WRITE(6,*)'Z > ALL OLD LAMBDA IN FX'
      WRITE(6,*)'Z= ',Z,'      NCNT = ',NCNT
      WRITE(6,*)'N= ',N,'      LAMBDA = ',LAMBDA
      WRITE(6,*)'OLDL GRID = ',(OLDLAM(IOLD),IOLD=1,NCNT)
C
C The next line stops the program with an error message & gives a
C symbolic stack dump (which traces the subroutine calls for the
C current position.
C
      ERROR=ERROR/ERROR
      STOP 'IN FX: ERROR'
100   Z1=OLDLAM(NZ-2)
      Z2=OLDLAM(NZ-1)
      Z3=OLDLAM(NZ)
      Q1=OLDQ(NZ-2)
      Q2=OLDQ(NZ-1)
      Q3=OLDQ(NZ)
C calculate Q(Z) by quadratic interpolation.
C
C
      QZ=Q3*(Z-Z1)*(Z-Z2)/((Z3-Z1)*(Z3-Z2))
     +   + Q1*(Z-Z2)*(Z-Z3)/((Z1-Z2)*(Z1-Z3))
     +   + Q2*(Z-Z1)*(Z-Z3)/((Z2-Z1)*(Z2-Z3))
C
C Complete the calculation of the integrand.
C
C COULD CHANGE QZ INTO A CALL ON FUNCTION QUAD(Z).
C PERHAPS THIS WOULD BE CLEARER.
C
999   CONTINUE
      EXPNT=-0.5*AN*(AN-1.0)*(DZ-DLAMBDA)**2.0
      EXPNT2=DEXP(EXPNT)
C This routine would be more efficient if the following test occurred 
C before calculating QZ, modified to RETURN if TRUE, else to proceed, 
C calculating QZ, then FX.
C
      IF (ABS(EXPNT2) .LT. EPSEXP) THEN
        FX=0.0
        FLAG=1
      ELSE
        FX=QZ*EXPNT2
      END IF
      RETURN
      END
C
C
C----------------------------------------------------------
