      program ratio
      integer nfiles, head, i, unit99, unita, start, step, out
      parameter(nfiles = 6, head = 8, unit99 = 1, unita = 2, out = 3)
      character*79 line
      integer a100(0:nfiles), n99, na
      real zeta99, zetaa, factor
      character*15 files(2, 0:nfiles)
c-----these are actually 100 times the a values
      data a100 / 99,  50, 60, 70, 80, 90, 95 /
      data files /	'K10000_99.ZETA', 'NEVER.USED',
     +			'K4000_5.ZETA',   'K199_5.RATIO',
     +			'K1200_6.ZETA',   'K249_6.RATIO',
     +			'K1200_7.ZETA',   'K332_7.RATIO',
     +			'K1200_8.ZETA',   'K499_8.RATIO',
     +			'K1200_9.ZETA',   'K999_9.RATIO',
     +			'K4000_95.ZETA',  'K1999_95.RATIO' /
         do 1000 i = 1, nfiles
         step = 100  - a100(i)
         start = (10000 - step) / step

         open( unit = unit99, file = files(1, 0), status = 'old' )
         call skip(head, unit99)
         if (.not. locate(start * step, unit99)) stop

         open( unit = unita, file = files(1, i), status = 'old' )
         call skip(head, unita)
         if (.not. locate(start, unita)) stop

         open( unit = out, file = files(2, i), status = 'new')
         call title(a100(i), out)
         factor = 10.0 * sqrt(0.01 * (100 -  a100(i)))

         do 500 j = start , 1, -1
            read( unit99, *) n99, zeta99
            read( unita, *) na, zetaa
            write(out, '(1x, i5, 1p, 2 ( 1x, e16.8), 1x, i5)')
     +        na, na * zetaa * factor / (n99 * zeta99),
     +        100.0 / (na * (100 - a100(i))), n99
            if (j .gt. 1) call skip(step - 1, unit99)
500      continue

         close(unit99)
         close(unita)
         close(out)
         print *,'Completed ',start, ' values in file ', files(2,i)

1000  continue
      end
c-----------------------------------------------------------
      subroutine skip(nlines, file)
      integer nlines, file, i
      do 100 i = 1, nlines
         read(file, *)
100   continue
      return
      end
c----------------------------------------------------------
      logical function locate(n, file)
      integer n, file, ok, try
100   read(file, *, iostat = ok) try
      if (ok .eq. 0) then
          if (try .eq. n) then
               backspace(file)
               locate = .true.
               return
          else
               goto 100
          endif
      else
          locate = .false.
          return
      endif
      end
c---------------------------------------------------------
      subroutine title(a100, file)
      integer a100, file
      write(file,'(1x, 2a, i2, a)')'This file contains ratios with',
     + '	a = ', a100, ' / 100  against a = 99 / 100 = 0.99 .'
      write(file, '(1x, a)' ) 'n	= from the a file'
      write(file, '(1x, a)' ) 'ratio	= phi(a, v)/v : phi(0.99, v)/v'
      write(file, '(1x, a)' ) 'v	= 1/(n(1 - a))'
      write(file, '(1x, a)' ) 'm	= matching n from 0.99 file'
      write(file, '(/, 1x, a5, 1x, a16, 1x, a16, 1x, a5)')
     +           'n', 'ratio', 'v', 'm'
      write(file, '( 1x, a5, 1x, a16, 1x, a16, 1x, a5)')
     +           '----', '---------------',
     +           '---------------', '----'
      return 
      end
c---------------------------------------------------------
